/*
 * miniboot/flash_entry.S
 *
 * entry point for the flash update utility.
 */

#include <linux/config.h>
#include <asm/system.h>
#include <alpha/regdef.h>
#include <alpha/pal.h>

	.text
	.set noat

	.align 3
	.globl	__start
	.ent	__start
__start:
/* 
 *  Get the gp value.
 */
	bis	zero,zero,zero
	br	t0, 1f
	.quad	_gp
1:	ldq	gp,0(t0)
/*
 *  Save the return address.
 */

	subq	$30,8,$30
	stq	ra,0($30)
/*
 *  zero out data at the end of the image
 */
	jsr	ra, doinitdata
/*
 *  Zero a few arguments and jump into flash_main.
 */
	bis	zero,zero,a0
	bis	zero,zero,a1
	bis	zero,zero,a2
	jsr	ra, flash_main

/*
 *  Return to whatever/whoever called us.
 */
	ldq	ra, 0($30)
	ret	zero, (ra)
	.end	__start 

	.align 3
	.globl	wrmces
	.ent	wrmces
wrmces:
	call_pal PAL_wrmces
	ret ($26)
	.end wrmces


	.globl	panic
	.ent	panic 2
panic:
	.option O1
	.frame sp, 0, ra

	bis a4, zero, a5
	bis a3, zero, a4
	bis a2, zero, a3
	bis a1, zero, a2
	bis a0, zero, a1
	bis $26, zero, a0
	jsr zero, flash_panic
	.end 	panic

